/*    
       This software may be used and distributed according to the terms of
       the GNU General Public License (GPL), incorporated herein by
       reference.  Drivers based on this skeleton fall under the GPL and
       must retain the authorship (implicit copyright) notice.
 
       This program is distributed in the hope that it will be useful, but
       WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
       General Public License for more details.
 */
package cricketdaemon.clientlib.parse;

import cricketdaemon.Util;
import cricketdaemon.clientlib.data.*;
import java.io.*;
import java.util.*;

/**
 * Parses subtypes contained within Distance Estimate Array.
 *
 * @author Allen Miu
 */
class DistanceEstimateArrayParseHandlerMap extends ParseHandlerMap
{
    public static DistanceEstimateArrayParseHandlerMap instance = 
	new DistanceEstimateArrayParseHandlerMap();

    protected DistanceEstimateArrayParseHandlerMap()
    {
	super();
	register("dist_est");
    }

    public boolean check_dist_est(Object o)
    {
	return o instanceof ArrayList;
    }

    public void parse_dist_est(Object dataStructure, String value)
	throws IOException 
    {
	BeaconRecord br = new BeaconRecord();
	ArrayList a = (ArrayList) dataStructure;
	a.add(br);
	
	StringReader sr = new StringReader(value);
	while(Field.newField(sr)) { // new dest_est record
	    Field.parseField(br, sr, 
			     DistanceEstimateParseHandlerMap.instance);
	}
    }
}




